/**************************************************
 ******      Annikas Regenprogramm V1.0      ******
 **************************************************
 ******     Progamm zum Roman "Curiepolis"   ******
 ******          von Fabian Herrmann         ******
 ******        geocities.ws/curiepolis       ******
 **************************************************
 ******             13. Juli 2017            ******
 **************************************************
 
 
 
**********************************************************************************
 
 Regenprasseln(), plitschtplatsch Kreiswellen()schauer ins nächtige Gaußblank. 
 Und Annika sah, dass es gut war. Regenprasseln() hurtigscharf, zernebelnde 
 Kreiswellen() zergleitende; Regenprasseln() Kaltgetropf, Kreiswellen() im 
 Zwodimensionalen, {züngelt (t)räumliche Tiefe unmerklich-unaufhaltsam herein?} 
 Regenprasseln(); Kreiswellen()pfützschwärze, sanftschwellendes Wind()gedrängel 
 herausgetehplusplusst aus {} – Tröpfelfall schrägstöbernd, mal hier-dorthin: 
 Schrödingerzufall qua Systemruf.
 
**********************************************************************************/
 
 
 
/* Regenparameter */

float fallstep  = 10;       // je größer, desto schneller fallen die Tropfen
float growsteps = 100;      // je größer, desto langsamer dehnen sich die Kreiswellen aus  
float tropf_laenge = 2;     // Länge der Tropfen

float perspekt_breit = 2;   // je kleiner, desto ausgeprägter der Größenunterschied zwischen nahen und fernen Kreiswellen
float perspekt_tiefe = 4;   // je größer, desto flacher erscheint die Perspektive

int N_Tropfen = 2000;       // Anzahl der Tropfen

int windwechsel = 500;      // je größer, desto seltener wechselt die Windrichtung





/*********************************************************************************

 Magnesiumbrilliantfontaine im Gewölbe: bringt als Einzigstes auf allen Vollzugs-
 ebenen Klassen hervor, die in ihm nicht enthalten sind; {Jmd. zieht'n Wecker aus'm 
 wolligen Mützi; musume würd annehmen, dass der Wecker vorher im Mützi war; rollt 
 1 Minigolfball aus'm funkelnden Strahl: war er womöglich nixniemalsnie drin – 
 Mysterium Aeternum;}

**********************************************************************************/
 

class tropfen
{
  float winkel;   // Fallwinkel (0 = senkrecht)
  float x, y;     // Tropfenposition
  float y_ende;   // Aufplitschhöhe
  color f;        // Farbe
  
  int status;  // 0 = Tropfen; 1 = Kreiswelle; 2 = Ende
  
  float r;        // Momentane Breite der Kreiswelle
  float r_max;    // Maximale    ''   ''     ''
  float growstep; // Kreiswellen-Wachstumsschritt
  
  int wellen;     // Anzahl Kreiswellenringe
  
  
  // Tropfen initialisieren: Fallwinkel, Start-X, Start-Y, Tropfenfarbe, Anzahl Kreiswellenringe
  tropfen(float w, float x0, float y0, color f0, int well)
  {
    winkel = w;
    f = f0;
    
    startnew(x0, y0, well);
  }
  
  
  // Neustarten nach Verschwinden der Kreiswelle: Start-X, Start-Y, Anzahl Kreiswellenringe
  void startnew(float x0, float y0, int w)
  {
    x = x0;
    y = y0;
    
    y_ende = get_ende(height/2 + 10, height-10);
    
    r = 0;
    r_max = (y_ende - height/2) / perspekt_breit;
    growstep = r_max / growsteps;
    
    status = 0;
    wellen = w;
  }
  
  
  // Je nach Modus: Tropfen oder Wellenringe zeichnen
  void zeige()
  {
    if(status == 0)
    {
      stroke(f);
      line(x, y, x+tropf_laenge*sin(winkel), y+tropf_laenge*cos(winkel));
    }
    else if(status == 1)
    {
      float re;
      for(int i = 0; i<wellen; i++)
      {
        stroke(farb[4 + (int)(11*(1 - r/r_max))]);
        re = r + (float)i * r/wellen;
        ellipse(x, y, re, re/perspekt_tiefe);
      }
    }
  }
  
  
  // Bewegung: Fallen (Tropfen) bzw. Expandieren (Wellen)
  void bewege()
  {
    if(status == 0)
    {
      x += fallstep*sin(winkel);
      y += fallstep*cos(winkel);
      
      if(y > y_ende) status = 1;
      return;
    }
    else if(status == 1)
    {
      r += growstep;
      
      if(r > r_max) status = 2;
    }
  }
  
  
  // In größerer Entfernung sollten mehr Tropfen aufkommen als vorne.
  // Zwischen Höhenkoordinaten y0 und y1 wird entsprechende Wahrscheinlichkeitsverteilung erzeugt.
  float get_ende(float y0, float y1)
  {
    float d = y1-y0;
    for(float yy = 0; yy<d; yy++)
    {
      float R = random(10000);
      if(R > (9800 + 190*yy/d)) return yy+y0;
    }
    
    return y1;
  }
}




/*********************************************************************************

 goldene Pagode – || ist'S 1 Funkturm 1 Raumschiff, winterblattlos Ambrunnenvordemtore 
 aus schlummerndem Juniabendglanz? – Herrscher der Gaußschen Ebene kolossrundruhend && 
 in unauslotbare Höhen schmal-schmalerschwingend Nadelspitzhinan. Zartblättrigste 
 Lamellen aus LeuchtGaze, prallplumpe Festung schwüngfüllig-steigend: leicht, feder-
 leicht, ruhmassenloses Phosphem, schwer, unendlich schwer, finale Wucht entarteter 
 Materie – vor Augenblicken, Handvoll Prozessorzyklen herausgeträumt aus ziffern-
 kristallinem Nichts, älter als Kraft && Kausalität hat'S Aufflammen der Mannig-
 faltigkeit, Entstehung des ersten Lebens gesehen, schimmert && schweigt && lächelt 
 in Tehgleichnullgleichinfinitmut.

**********************************************************************************/
 

// Zeichnen der Pagode. Bitte mit Parametern experimentieren! Idee zum Algorithmus
// stammt aus Friedrich && Sebastian Belzner: "Kreative Grafik mit dem Atari ST", 1990,
// S. 120 ff.
void sinusraute(float x0, float y0, float fy, float rx, float ry, float s, float w1, float w2)
{
  float xx = 0, yy = 0, x, y, w;
  boolean firstp = true;
  
  for(w=w1; w<w2; w+=s)
  {
    float degw = 180*w/PI;
    float degw2 = degw*degw;
    x = rx * pow(sin(w), 7) * cos(PI*degw2/180);
    y = ry * cos(w) * fy;
 
    if(y<0)
    {
      stroke(farb[1]);
    }
    else
    {
      /*********************************************************************************
       Sie ist doppelt, seht, ein Schwächeres steht drunter: die Ebene ist blank, 
       unvorstellbar blank, so blank, wie'S nur ein perfekt zweidimensionales Gebilde – 
       zarte Fastnichtwelt vom Raummaß 0, Mitternachtshauchbran, polierter Schatten 
       sein kann.
      **********************************************************************************/
      
      x -= y/2;
      stroke(farb[2]);
    }
    if(!firstp)
    {
      line(x+x0, y+y0, xx+x0, yy+y0);
    }
    
    xx = x;
    yy = y;
    firstp = false;
  }
}


// Tropfenfeld erzeugen
tropfen[] T = new tropfen[N_Tropfen];

// Puffer für das Hintergrundbild
PImage S;



/*********************************************************************************
 
 Eswarneunzehnhundertdreiundneunzig&&wirwusstennichwohin-Klacktatur mit Spiralkabel – 
 stahlblauer Märzmorgen in Cyberia: Große Sehnsucht Hoffnung Freiheit – Zwotastmaus & 
 Zehärrtee in sechshundertvierzig-icks-vierhundertachtzig-icks-sechzehn: Farbpalette 
 passend bemessen für'n hübsches Mädchen in ebendiesem Alter.

**********************************************************************************/

// Die ersten vier von 16 Farben
color farb[] = {color(0), color(210, 150, 0), color(70, 50, 0), color(255)}; 

// Animationsschrittzähler
int count = 0;


// Bild vorbereiten
void setup()
{
  noSmooth();      // Keine Konturenglättung
  fullScreen();    // Kompletten Schirm nutzen (allerdings wohl meist nicht 640x480)
  background(0);   // Hintergrund schwarz
  
  
  noFill();        // Füllen der Figuren ausschalten
  
  // Weitere zwölf Farben anhängen (Graustufen)
  for(int i=0; i<12; i++)
  {
    farb = append(farb, color(i * 255/30));
  }
  
  
  /******************************************************************************************************
   Die goldene Pagode sagt: „Jedes M. löst sich, indem man nicht drüber nachdenkt.“ Schweigt lächelt IST.
  *******************************************************************************************************/
  
  for(float rx=50; rx<301; rx+=50)
  {
    sinusraute(width*0.75, height/2, 1, rx, 350, PI/180, 0, 2*PI);
  }
  
  
  /******************************************************************************************************
  Horizontfern aus samtigem Dunst steigend; nextnah, dass kore die Hand ausstrecken könnt, 
  doch Annika streckt die Hand nicht aus, schaut.
  *******************************************************************************************************/
  
  float y = height/2+12;
  for(int c=0; c<12; c++, y--)
  {
    stroke(farb[c+4]);
    line(0, y, width, y);
  }
  
  S = get(); // Hintergrund speichern
  
  // Einzelne Tropfen initialisieren
  for(int i=0; i<N_Tropfen; i++) T[i] = new tropfen(PI/8, -getoffset(PI/8) + random(width + getoffset(PI/8)), -height/2 + random(height/2), color(255), 1 +(int)random(4));
}


// Links-Rechtsverschiebung der Tropfen-Startpositionen je nach Fallwinkel
// Übrigens werden die Tropfen in dieser Version nur oberhalb des Schirms gestartet,
// daher können sie nicht seitlich ins Bild fallen.
// Aufgabe: Programm so verändern, dass sie auch seitlich hereinkommen können.
float getoffset(float w)
{
  float x;
  
  x = tan(w) * height/2;
  return x;
}



/*********************************************************************************

 Hochfahren in nullkommafünf Herzklopfern. Zwohundert Kilobeit Oh-S ROMweis fest-
 gedrahtet, da kann, dank fingerkupprunder Reset-Taste (gleich neben „Turbo“: 
 zwanzig vs. siebenkommafünf Giga, orangerot gedigitalziffunkelt), nix schiefgehen. 
 Annika schneidersitzt sich nieder auf gekachelten Tempelboden –, #ffff55 auf 
 #0000aa Grundvomsatze && -algorithmus (&Annika entsinnt sich, wie sie, als ganz 
 klitzekleines Mägdgen, immer „Alogarithmus“ zu sagen pflegte; nette mathematische 
 Verschlingung!), nix Textmodus: jedes Zeichen acht-icks-acht gemalt & Grafiken 
 jedernorts in jegliche Datei einstickbar. Annika programmiert – Dunkelwind im Haar 
 && violettendes Himmelsrund (mit 1 Planeten: Jupiter) über sich – direktenhändchens 
 von der Konsole, in Curie++; Zweck des Curiepolis-PCs! && kein Mittel-zum-;}. 
 Würfel>>schattiert()>>rotiert() in 1 Befehl; simplstes Programm mit Schlauf && 
 Mausführung 3zeilern. Kein sklavenmoralinsaures Gesetz in Annika – nein, ein 
 Sourcecode ist'S, ein kurzer diesmal, doch schön.
 
**********************************************************************************/

// Hauptfunktion.
// Wird in Endlosschleife durchlaufen. Programmende: [Esc] drücken.
void draw()
{
  image(S, 0, 0); // Hintergrund aus Puffer zeichnen
  
  // Tropfen anzeigen
  for(int i=0; i<N_Tropfen; i++)
  {
    T[i].zeige();
  }
  
  // Tropfen bewegen
  for(int i=0; i<N_Tropfen; i++)
  {
    T[i].bewege();
    
    // Ende? (Tropfen aufgeplitscht && Kreiswelle zerlaufen) -- Neustart des Tropfens.
    if(T[i].status == 2)
    {
      T[i].startnew(-getoffset(T[i].winkel) + random(width + getoffset(T[i].winkel)), -height/2 + random(height/2), 1 + (int)random(4));
    }
    
    
  }
  
  count++; // Animationszyklenzähler erhöhen
  
  // Windwechsel fällig?
  if(count == windwechsel)
  {
    // Neue zufällige Windrichtung
    float w = -PI/4 + random(PI/2);
    
    // Fallrichtung der einzelnen Tropfen ändern
    for(int i=0; i<N_Tropfen; i++)
    {
      T[i].winkel = w;
    }
    
    // Zyklen wieder von vorne zählen
    count = 0;
  }
}


/*********************************************************************************

 Regenprasseln(); Kreiswellen() Goldpagodenspiegelung verflimmernd; während wahr; 
 && von Mal zu Mal längerdauernd, endlich mischdurchwischt-zugleich: Fallen 
 Plitschen Kreiswellen(); Woran denn das liegt? {Zufallsverteilung der Fallhöhen 
 && bedeutender Unterschied der Dauer von Niedersturz versus Wellenzerfließen – 
 so Annika nach 1 Prischen Grübelkübel} – na, Pagode? t>0 doch nicht ganz einerlei, 
 watt? Doch der Regen silbert nur ihre Spiegelung, über'S ReImSchauerfeld gold-
 lächelIST's: „Gibt bereits zuviel Weisheit.“

**********************************************************************************

 Musume kauert schreibt Programmzeilen, sieben Säulen hat'S Tempelchen: die tragen 
 ein Fastrund aus Marmor; und die achte steht frei im Südosten, schwarzblätter-
 murmelnd Maulbeerbaum dahinter, Tim et Norbert am Altar davor. Annika & Curie-
 polis-PC auf Penrosenboden – Kraftfelder, Geschwirr virtueller Teilchen, in 
 winzige Himmelskörper gepresst, Kerne aus purer bebender Spannung, zerbersten – 
 traumhaft-flüchtiger Kollaps der Wellenfunktion – zu reellen Ladungsblitzen, den 
 Rechner mit Energieflussdichte und echten Zufallszahlen fütternd – leiser Sommer-
 sturm faucht von Kühlrippen –; unendlich das Sechseckmuster der Marmorplatten, 
 Gaußsche Zahlenebene ohne Rand und Horizont, Annika mittdrin, lackschwarzes 
 Schöpfchen plus Glanzsichel, arktische Fünfzehntausendkelvinaugen halbgeschlossen 
 schimmernd im Zehärrteelicht, in tiefster Tiefe von Curiepolis Stadt – drunter, 
 von mildem Pazifikwasser umbrodelt, nur noch menschenleere Fabriken Nahrungstanks 
 Kraftwerke Knäuel der Maglevröhren –, und die Nacht schwingt sich herab an alpin-
 ragenden Graphetonklippen, legt sich, olbersgefiedertes Halbrund, über Kore 
 Computer. Und ein augenzwinklang – zitronengelb anheimelnd Curie++sternbilder auf 
 Blaudämmergrund, Anweisung Ausdruck Variable Struktur Klasse Schleife Funktion... 
 für Dauer des gerade noch psychisch fassbaren Chronons zwischen Herab und Herauf 
 des Lides denkt Annika: anders als Hinterföhren-daheim! Papaul Mamsch Dr. Korff 
 sandige Lichtungen im Schilfwald, auf denen man nachmittagelang lesen kann – 
 Erinnerungscumuliecstatici mit Goldrand. (Sollte nicht, bei all dem damaldortigen 
 Ärger, herste Erleichterung des End!lich!vorbei! herrschen? Nee – chi(em)gau; im 
 Schilfwald fühlte man sich winzig oder geborgen oder beides, und bei Dr. Korff – 
 oooach – Lid interrupted aufwärts; Fabius ruht in seiner seidenpapierschmucken 
 Schachtel in Annikas Tasche.) Der Curiepolis-PC braust kaumhörbar, schnurrt && 
 burrt wie die Bienen, entfaltet sein Laternamagicazelt über Annika v. Brabant, 
 schlummerschattenbuntbehütend im Unendlicherlei der Gaußschen Ebene, über der'S 
 regnen soll. Wozu hat kore 1 wackren Curiepolis-PC? Wer nicht programmiert, soll 
 kein' Kaffee trinken; wer keinen Kaffee trinkt, der nicht programmieren – S ne 
 zentrale Cultourmticklneck der Moderne!

**********************************************************************************/